unit bitwrite;

interface

procedure write_bits(w, length: byte);
procedure set_bitpointer(p: pointer);
function bitwrite_position: longint;

implementation

var
  bitcounter: longint;
  bitpointer: pointer;
type bitarray=array[0..65534] of byte;
var
  bitfield: ^bitarray absolute bitpointer;


function bitwrite_position: longint;
begin
  bitwrite_position := bitcounter;
end;

procedure set_bitpointer(p: pointer);
begin
  bitcounter := 0;
  bitpointer := p;
end;


procedure write_bits(w, length: byte); { length max. 8 }
var
  wert: byte;
  mask: word;
  buffer: word;
  bytepos: word;
  bitoffset: byte;
   { Bitposition ab der an aktueller Byteposition geschrieben wird }
begin
  if (length > 0) and (length < 9) then
  begin

    bytepos := bitcounter shr 3; { Division durch 8 }
    buffer := bitfield^[bytepos] + bitfield^[bytepos+1] shl 8;
    { buffer an aktueller Position gefllt }

    bitoffset := bitcounter - bytepos shl 3; { bitcounter MOD 8 }

    mask := not ((1 shl length - 1) shl bitoffset);
    { Maske, um Bereich wo Bits reinsollen auszublenden }

    wert := w and (1 shl length - 1);
    { sicherstellen dass Wert wirklich die richtige Bitbreite hat }
    { sicherheitshalber obenrum abschneiden }

    buffer := buffer and mask + wert shl bitoffset;

    bitfield^[bytepos] := buffer and $FF;
    if bitoffset + length > 8 then
      bitfield^[bytepos+1] := buffer shr 8;

    inc(bitcounter, length);

  end;
end;


end.