{G+}
unit grpfile;

interface

function open_file_grp(n: string): byte;
procedure readfile_grp(poi: pointer; len: word);
procedure close_grpfile;
procedure set_grpfile(n: string);

var

  filesize_grp: longint;

implementation

var

  header: pointer;
  header_di: word;
  file_offset: longint;
  gf: file;
  file_open: bytebool;
  grpfilename: string[12];
  search_ext: string[3];
  search_name: string[8];


procedure set_grpfile(n: string);
begin

  grpfilename := n;
  file_open := false;

end;


function grpfile_seek: byte; assembler;
asm

  les di, header
  mov header_di, di
  lea si, search_ext

  mov dx, es:[di]
  add di, 2

  xor ch, ch
  xor ah, ah
  mov al, ds:[si]
  mov bx, si
  @ext_loop:
    mov cl, es:[di]
    inc cl
    repe cmpsb
    jnz @skip
    mov ah, 0ffh
    jmp @ext_found
    @skip:
    add cx, 2
    add di, cx
    mov si, bx
  dec dx
  jnz @ext_loop

  or ah, ah
  jz @no_ext_match

  @ext_found:

  mov cx, es:[di]  { offset zu den Namentabellen ausrechnen }
  mov di, header_di
  add di, cx
  lea si, search_name

  mov dx, es:[di]
  add di, 2

  xor ch, ch
  xor ah, ah
  mov al, ds:[si]
  mov bx, si
  @name_loop:
    mov cl, es:[di]
    inc cl
    repe cmpsb
    jnz @skip2
    mov ah, 0ffh
    jmp @name_found
    @skip2:
    add cx, 8
    add di, cx
    mov si, bx
  dec dx
  jnz @name_loop

  or ah, ah
  jz @no_name_match

  @name_found:
  db 66h; mov ax, es:[di]
  add di, 4
  db 66h; mov word ptr file_offset, ax
  db 66h; mov ax, es:[di]
  db 66h; mov word ptr filesize_grp, ax
  xor ax, ax

  jmp @ende

  @no_name_match:
  mov ax, 2
  jmp @ende

  @no_ext_match:
  mov al, 1

  @ende:

end;


function open_file_grp(n: string): byte;
  var i, ii: byte;
      l: byte absolute n;
      headersize: word;
      errorcode: byte;
begin
  open_file_grp := 0;
  search_ext := '';
  for i := 1 to l do n[i] := upcase(n[i]);
  n := n + ' '; i := 1;
  while (i < l-1) and (n[i+1] <> '.') do inc(i);
  if i = l-1 then search_ext := ''
  else
  begin
    for ii := i+2 to l-1 do search_ext[ii-i-1] := n[ii];
    search_ext[0] := chr(l-i-2);
  end;
  search_name := n; search_name[0] := chr(i);


  {writeln('>',search_name,'<  >',search_ext,'<');}

  if not file_open then
  begin
    assign(gf, grpfilename);
    {I-}
    reset(gf, 1);
    {I+}
    if ioresult <> 0 then
    begin
      writeln('error opening ', grpfilename);
      halt(3);
    end;
    blockread(gf, headersize, 2);
  end
  else
    seek(gf, 2);
  file_open := true;
  getmem(header, headersize);
  blockread(gf, header^, headersize);
  errorcode := grpfile_seek;
  freemem(header, headersize);
  seek(gf, file_offset);
  if errorcode > 0 then
  begin
    close(gf);
    assign(gf, search_name+'.'+search_ext);
    {$I-}
    reset(gf, 1);
    {$I+}
    if ioresult <> 0 then open_file_grp := 3;
  end;

end;

procedure readfile_grp(poi: pointer; len: word);
begin
  blockread(gf, poi^, len);
end;

procedure close_grpfile;
begin
  close(gf);
  file_open := false;
end;

end.