
{$G+}
uses scanzsm6;


const nyb_map: array[0..15] of byte =
      (0, 1, 2, 4, 8, 16, 32, 64, 128, 192, 224, 240, 248, 252, 254, 255);

type byte_type = array[0..3999] of byte;

var
  fname, datefname, dmf_fname: string;

  i,ii: word;
  old_num_smpentries: byte;
  _4bitsmp_sumbytes: longint;
  last_smp, conv, buf, nyb: byte;
  nybdelta: array[0..1] of byte;
  c: word;
  closest: word;
  closest_pos: byte;
  msg_raw_size: word;
  msg_raw_pointer: pointer;

  msg_pointer: pointer;

  msg: ^byte_type absolute msg_pointer;
  msg_raw: ^byte_type absolute msg_raw_pointer;

  msg_pos, msg_raw_pos: word;

procedure load;
  var err: byte;
begin
  if paramstr(1) = '' then
  begin
    write('ZSM-Datei (ohne Erw.): ');
    readln(fname);
  end
  else
    fname := paramstr(1);
  datefname := fname + '.txt';
  dmf_fname := fname + '.dmf';
  fname := fname + '.zsm';
  err := load_zsm(fname);
  if err = 3 then
  begin
    writeln('ZSM Version is greater than 1. Can only process v.1');
    halt(3);
  end;
  if err > 0 then
  begin
    writeln('Error opening ', fname);
    halt(1);
  end;
end;

procedure write_log;
  var f: text;
      i, count: byte;
      s, s2: longint;
begin
  assign(f, 'zsmopt.log');
  rewrite(f);

  writeln(f, fname);
  writeln(f);
  writeln(f, 'total amount of needless bytes cut from samples: ',
    smpcut_trunc_total + smpcut_play_total);
  writeln(f, 'total bytes cut by measuring effective playlengths: ',
    smpcut_play_total);
  writeln(f, 'total bytes cut by truncating silent sample ends: ',
    smpcut_trunc_total);
  s := 0; s2 := 0;
  for i := 1 to zsmheader.sample_entries do inc(s, smpinfo[i].length);
  for i := 1 to zsmheader.sample_entries do inc(s2, old_smp_len[i]);
  writeln(f, 'sample data is now ', s/s2*100:0:2, ' % of its original size');
  writeln(f, 'from ', s2, ' bytes to ', s, ' bytes');
  writeln(f);

  count := 0;
  for i := 1 to zsmheader.sample_entries do
  if old_smp_len[i] <> smpinfo[i].length then
  begin
    inc(count);
    writeln(f);
    writeln(f, 'sample #', i, ' from ', old_smp_len[i], ' bytes to ',
      smpinfo[i].length, ' (', smpinfo[i].length/old_smp_len[i]*100:0:2, ' % )');
    writeln(f, 'bytes cut by measuring effective playlengths: ',
      smpcut[i].play_trunc);
    if smpinfo[i].length = 0 then
    begin
      writeln(f,' REMOVED COMPLETELY because not used at all');
      writeln(f); writeln(f);
    end
    else
    begin
      writeln(f, 'bytes cut by truncating silent end: ', smpcut[i].null_trunc);
      if smpcut[i].loop_dissolved then writeln(f, ' loop dissolved')
      else writeln(f);
    end;

  end;
  writeln(f);writeln(f, count, ' samples were cut');


  close(f);
end;



procedure sim_row;
begin
  read_row;

  simulate_row;

  if actual_row = patternheader.rows + 1 then
  begin
    write(actual_sequ, '/');
    goto_next_sequ;
  end;
end;


function map_pos: byte; assembler;
asm
  mov di, 0ffffh
  mov dl, conv
  xor dh, dh
  mov bx, 15
  mov cl, last_smp
  @loop:
    mov al, cl
    add al, ds:[offset nyb_map + bx]
    xor ah, ah
    sub ax, dx
    jns @positiv
    neg ax
    @positiv:
    cmp ax, di
    jae @skip
    mov di, ax
    mov ch, bl
    @skip:
  dec bx
  jns @loop
  mov al, ch
end;




procedure conv_smp_to_4bit(smp: byte);
begin
  last_smp := 128; { vorzeichenlose Null-Linie }
  smp_pointer := sample_pointer[smp];

  for c := 0 to smpinfo[smp].length - 1 do
  begin
    if c = smpinfo[smp].loopstart then
    begin
      {asm mov al, last_smp; add al, 128; mov last_smp, al end;}
      asm add last_smp, 128 end;
      smpinfo[smp].loopst_phase := last_smp;
      asm add last_smp, 128 end;
      {asm mov al, last_smp; add al, 128; mov last_smp, al end;}
    end;

    conv := onesample^[c];
    {asm mov al, conv; add al, 128; mov conv, al end;}
    asm add conv, 128 end; { input-sample zu vorzeichenlos konvertieren }

    nybdelta[c and 1] := map_pos{_(last_smp, conv{onesample^[i])};

    conv := nyb_map[nybdelta[c and 1]];
    asm mov al, last_smp; add al, conv; mov last_smp, al end;


    if c and 1 = 1 then
      onesample^[c shr 1] := nybdelta[1] + nybdelta[0] shl 4;

  end;
  inc(_4bitsmp_sumbytes, smpinfo[smp].length shr 1);
  if c and 1 = 0 then
  begin
    onesample^[c shr 1+1] := nybdelta[0] shl 4;
    inc(_4bitsmp_sumbytes);
  end;

end;



procedure fix_sample_loopstarts;
begin

  for i := 1 to zsmheader.sample_entries do
    if smpinfo[i].loopstart > smpinfo[i].length then
      smpinfo[i].loopstart := smpinfo[i].length;


end;


procedure copy_old_header;
begin
  with zsmheader_new do
  begin
    kennung := $4D54535A;
    version := 4;
    move(zsmheader.titel, titel, 30);
    move(zsmheader.composer, composer, 20);

    date_year := 0;
    date_month := 0;
    date_day := 0;

    sample_entries := zsmheader.sample_entries;
    sequencer_entries := zsmheader.sequencer_entries;
    sequencer_loopstart := zsmheader.sequencer_loopstart;
    sequencer_loopend := zsmheader.sequencer_loopend;
    patterndata_size := zsmheader.patterndata_size;
    cmsg_size := msg_pos;
  end;

end;

procedure get_date;
  var f: text;
begin
  {$I-}
  assign(f, datefname);
  reset(f);
  {$I+}
  if ioresult <> 0 then exit;
  readln(f, zsmheader_new.date_year);
  readln(f, zsmheader_new.date_month);
  readln(f, zsmheader_new.date_day);
  close(f);
end;


procedure import_dmf_cmsg;
  var f: file;
begin
  assign(f, dmf_fname);
  reset(f, 1);
  seek(f, 70);
  blockread(f, msg_raw_size, 2);
  dec(msg_raw_size);
  getmem(msg_raw_pointer, msg_raw_size);
  seek(f, 75);
  blockread(f, msg_raw_pointer^, msg_raw_size);
  close(f);
end;


procedure encode_cmsg;
var
  width, start: byte;
  c: word;
  starti: byte;
begin
  msg_pos := 0; msg_raw_pos := 0;
  if msg_raw_size = 0 then exit;

  getmem(msg_pointer, 2 * msg_raw_size);
  cmsg_poi := msg_pointer;


  msg^[msg_pos] := msg_raw_size div 40; {erstes byte wieviele Zeilen}
  inc(msg_pos);

  starti := 0;
  c := 0;
  while (c < msg_raw_size)
    and ((msg_raw^[c] = 32) or (msg_raw^[c] = 0)) do inc(c);
  starti := c div 40;
 { Leerzeilen am Anfang sind bersprungen wenn man mit Offset starti beginnt }


  for i := starti to msg^[0] - 1 do
  begin

    msg_raw_pos := i * 40 + 39;
    while (msg_raw_pos mod 40 > 0) and ((msg_raw^[msg_raw_pos] = 32)
      or (msg_raw^[msg_raw_pos] = 0)) do dec(msg_raw_pos);
    width := msg_raw_pos mod 40 + 1;
    if (width = 1) and ((msg_raw^[msg_raw_pos] = 32)
      or (msg_raw^[msg_raw_pos] = 0)) then width := 0;

    start := 0;
    if width > 0 then begin
      msg_raw_pos := i * 40;
      while (msg_raw_pos mod 40 < 39) and ((msg_raw^[msg_raw_pos] = 32)
        or (msg_raw^[msg_raw_pos] = 0)) do inc(msg_raw_pos);
      start := msg_raw_pos mod 40;
    end;

    if width = 0 then
    begin
      msg^[msg_pos] := 0; inc(msg_pos);
    end
    else
    begin
      if start > 0 then
      begin
        msg^[msg_pos] := start + 128; inc(msg_pos);
      end;
      msg^[msg_pos] := width - start; inc(msg_pos);

      c := i * 40 + start + 1;
      while (c < i*40+start+width) and (msg_raw^[c] = msg_raw^[c-1]) do inc(c);
      if c = i*40+width+start then
      begin
        inc(msg^[msg_pos-1], 64);
        msg^[msg_pos] := msg_raw^[c-1];
        inc(msg_pos);
      end
      else
      begin
        move(msg_raw^[i * 40 + start], msg^[msg_pos], width - start);
        inc(msg_pos, width - start);
      end;
    end;
  end;


  { Null-Linien vom Ende kappen }
  i := 0;
  while msg^[msg_pos - i - 1] = 0 do inc(i);

  dec(msg^[0], i+starti);

  dec(msg_pos, i);

  if msg^[0] = 0 then msg_pos := 0; { Problem gefixt? }

  { Problem: es werden zwar 0 Linien indiziert (Gre=1, 0 Linien), aber
  { eigentlich sollte dann Gre = 0 sein und keine weiteren Daten folgen }


end;


begin

  reset_simu;

  load;

  if zsmheader.version = 4 then
  begin
    writeln(fname, ' is already version 3. aborting.');
    halt(0);
  end;

  import_dmf_cmsg;
  encode_cmsg;


  copy_old_header;
  get_date;


  writeln(fname);
  writeln(zsmheader.sample_entries, ' samples');
  writeln('simulation through sequencer... entries done:');
  goto_sequ(1);

  while actual_sequ < zsmheader.sequencer_loopend do sim_row;
  for i := 0 to patternheader.rows do sim_row;
  for i := 0 to patternheader.rows do sim_row;

  writeln;

  evaluate_scan;

  apply_sample_cuts;


  for i := 1 to zsmheader.sample_entries do
    trunc_null_bytes_from_sample(i);

  writeln(smpcut_trunc_total+smpcut_play_total, ' bytes could be cut from sample data');

  _4bitsmp_sumbytes := 0;
  writeln('converting samples to 4 bit delta...');


  writeln(zsmheader.sample_entries, ' samples');

  for i := 1 to zsmheader.sample_entries do
  begin
    write(i,'... ');
    if smpinfo[i].length = 0 then write('(zero length)... ')
      else
        conv_smp_to_4bit(i);
  end;
  write('OK'); writeln;


  fix_sample_loopstarts;

  {
  if old_num_smpentries > zsmheader.sample_entries then
  writeln('sample entries cut from ', old_num_smpentries, ' to ', zsmheader.sample_entries,
    '(', (old_num_smpentries-zsmheader.sample_entries)*6, ' bytes saved);
  }

  write('saving zsm... ');
  if save_zsm_4bitsmp(fname) = 0 then
    writeln('OK')
  else
    writeln('error saving ', fname);

  if smpcut_trunc_total+smpcut_play_total > 0 then
  begin write_log; writeln('see zsmopt.log for details'); end;

end.