{$M $4000,0,130000}
{128064}
uses dos, crt;
type zsm_header = record
  kennung: longint; (* $4D54535A "ZSTM" *)
  version: byte;
  titel: array[0..29] of char;
  composer: array[0..19] of char;
  year: word;
  {
  date_month: byte;
  date_day: byte;
  sample_entries: byte;
  sequencer_entries: word;
  sequencer_loopstart: word;
  sequencer_loopend: word;
  patterndata_size: word;
  cmsg_size: word;
  }
end;

{
type zsm_info = record
  title: string[25];
  composer: string[20];
  fname: string[8];
  year: word;
  size: longint;
  id: word;
end;
}

type zsm_titletype = array[0..2500] of string[25];
type zsm_composertype = array[0..2500] of string[20];
type zsm_fnametype = array[0..2500] of string[8];
type zsm_wordtype = array[0..2500] of word;
type zsm_longinttype = array[0..2500] of longint;

const
  ascweigh: array[48..122] of byte =
  (1, 2, 3, 4, 5, 6, 7, 8, 9, 10, { Ziffern }
   0, 0, 0, 0, 0, 0, 0, { Satzzeichen etc. }
   11, 12, 13, 14, 15, 16, 17, 18, 19, { ABCDEFGHI }
   20, 21, 22, 23, 24, 25, 26, 27, 28, { JKLMNOPQR }
   29, 30, 31, 32, 33, 34, 35, 36,     { STUVWXYZ }
   0, 0, 0, 0, 0, 0, {Satzzeichen etc. }
   11, 12, 13, 14, 15, 16, 17, 18, 19, { abcdefghi }
   20, 21, 22, 23, 24, 25, 26, 27, 28, { jklmnopqr }
   29, 30, 31, 32, 33, 34, 35, 36);    { stuvwxyz }
   hex2byte: array[48..70] of byte =
   (0,1,2,3,4,5,6,7,8,9,0,0,0,0,0,0,0,10,11,12,13,14,15);
   nyb2hexch: array[0..15] of char =
   ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
   titlestring: string = '+ZSMPLAYSTARTER+ v.01';
   irqlist: array[1..7] of byte = (2,3,5,7,11,12,15);
   dmalist: array[1..6] of byte = (1,3,4,5,6,7);

var
  key: bytebool;
  ascw: array[0..255] of char;
  dirinfo: searchrec;
  {
  title: array[1..1024] of string[24];
  composer: array[1..1024] of string[20];
  year: array[1..1024] of word;
  fname: array[1..1024] of string[8];
  size: array[1..1024] of longint;
  }
{  zsm: array[1..999] of zsm_info;}
  plist: array[0..100] of word; { 0 fr swapping }
  plistid: array[0..100] of word;
  playlist_loop: bytebool;
  playlist_random: bytebool;
  plrnd: array[1..100] of byte;
  pl_cfgfname: array[1..100] of string[8];
  pl_cfgcount: byte;
{  swapbuf: zsm_info;}
  fnam: string[12];
  fnaml: byte absolute fnam;
  filecount, zsmcount, failcount: word; { zsmcount: anzahl gueltiger dateien }
  plistcount: word;
  zsmheader: zsm_header;
  toomany: bytebool;
  cmpstr: array[0..1] of string[25];
  selectpos, selectplpos: byte;
  ch: byte;
  chh: char absolute ch;
  ext_key: bytebool;
  fill: string[25];
  filespos, plistpos: integer;
  mode: byte;

  zsm_titles_pointer: pointer;
  zsm_composers_pointer: pointer;
  zsm_fnames_pointer: pointer;
  zsm_years_pointer: pointer;
  zsm_sizes_pointer: pointer;
  zsm_ids_pointer: pointer;

  zsm_title: ^zsm_titletype absolute zsm_titles_pointer;
  zsm_composer: ^zsm_composertype absolute zsm_composers_pointer;
  zsm_fname: ^zsm_fnametype absolute zsm_fnames_pointer;
  zsm_year: ^zsm_wordtype absolute zsm_years_pointer;
  zsm_size: ^zsm_longinttype absolute zsm_sizes_pointer;
  zsm_id: ^zsm_wordtype absolute zsm_ids_pointer;

  mixfreq: word;

  sb_base: word;
  sb_irq, sb_dma: byte;
  sb_set: bytebool;
  irqpos: byte;
  dmapos: byte;
  blasterstring: string[32];
  freqstring: string[16];

  sortedstate: string[25];

procedure find_dma_and_irq_pos;
begin

  irqpos := 1;
  while not (sb_irq = irqlist[irqpos]) do inc(irqpos);
  dmapos := 1;
  while not (sb_dma = dmalist[dmapos]) do inc(dmapos);

end;


function blasterbase2str(val: word): string;
  var s: string[3];
begin

    s[1] := nyb2hexch[val shr 8];
    s[2] := nyb2hexch[(val and $FF) shr 4];
    s[3] := nyb2hexch[val and $F];
    s[0] := chr(3);

    blasterbase2str := s;
end;


procedure make_blasterstring;
  var
    s, s2: string[2];
begin
  str(irqlist[irqpos],s);
  str(dmalist[dmapos],s2);
  blasterstring := ' /BLASTER'+blasterbase2str(sb_base)+s+s2;
end;


procedure get_sbenv;
  var
    sb_env: string;
    i: byte;
begin
  sb_base := 0;
  sb_env := getenv('BLASTER');
  for i := 1 to ord(sb_env[0]) do
    sb_env[i] := upcase(sb_env[i]);
  if sb_env[0] = chr(0) then exit;
  i := pos('A', sb_env); inc(i);
  inc(sb_base, word(hex2byte[ord(sb_env[i])])*256); inc(i);
  inc(sb_base, word(hex2byte[ord(sb_env[i])])*16); inc(i);
  inc(sb_base, hex2byte[ord(sb_env[i])]); inc(i);
  i := pos('I', sb_env); inc(i);
  sb_irq := hex2byte[ord(sb_env[i])];
  i := pos('D', sb_env); inc(i);
  sb_dma := hex2byte[ord(sb_env[i])];
end;

procedure get_memory;
begin
  getmem(zsm_titles_pointer, 26*2001);
  getmem(zsm_composers_pointer, 21*2001);
  getmem(zsm_fnames_pointer, 9*2001);
  getmem(zsm_years_pointer, 2*2001);
  getmem(zsm_sizes_pointer, 4*2001);
  getmem(zsm_ids_pointer, 2*2001);
end;


procedure find_files;
  var
    i: word;
    tx, ty: byte;
begin
  tx := wherex + 1;
  ty := wherey;
  filecount := 0;
  findfirst('*.zsm', $3F, dirinfo);
  while doserror = 0 do
  begin
    inc(filecount);
    gotoxy(tx, ty); write(filecount:4);
    if filecount > 2000 then begin filecount := $FFFF; exit; end;
    fnam := dirinfo.name;
    while fnam[fnaml] <> '.' do dec(fnaml);
    dec(fnaml);
    zsm_fname^[filecount] := fnam;
    findnext(dirinfo)
  end;
end;


procedure read_in_details;
  var
    f: file;
    i: word;
    fsiz: longint;
    tx, ty: byte;

begin
  tx := wherex + 1;
  ty := wherey;
  zsmcount := 0; failcount := 0;
  for i := 1 to filecount do
  begin
    assign(f, zsm_fname^[i]+'.zsm');
    reset(f, 1);
    fsiz := filesize(f);
    blockread(f, zsmheader, sizeof(zsmheader));
    close(f);
    if (zsmheader.kennung = $4D54535A) and (zsmheader.version = 4) then
    begin
      inc(zsmcount);
      move(zsmheader.titel, zsm_title^[zsmcount][1], 25);
      zsm_title^[zsmcount][0] := chr(25);

      move(zsmheader.composer, zsm_composer^[zsmcount][1], 20);
      zsm_composer^[zsmcount][0] := chr(20);
      zsm_fname^[zsmcount] := zsm_fname^[i];

      zsm_year^[zsmcount] := zsmheader.year;
      if zsmheader.year = 0 then zsm_year^[zsmcount] := $FFFF;

      zsm_size^[zsmcount] := fsiz;
      zsm_id^[zsmcount] := zsmcount;
    end
    else
      inc(failcount);
    gotoxy(tx, ty); write(trunc(longint(i)*100 / filecount):3, '%');
  end;
end;

procedure trunc_lengths;
  var
    bufstr: string[24];
    buflen: byte absolute bufstr;
    i: word;
begin
  for i := 1 to zsmcount do
  begin
    move(zsm_title^[i], bufstr, 26);
    buflen := 25;
    while (buflen > 0) and (bufstr[buflen] = chr(0)) do dec(buflen);
    zsm_title^[i][0] := chr(buflen);
    move(zsm_composer^[i], bufstr, 21);
    buflen := 20;
    while (buflen > 0) and (bufstr[buflen] = chr(0)) do dec(buflen);
    zsm_composer^[i][0] := chr(buflen);
    {
    move(zsm[i].fname, bufstr, 9);
    buflen := 8;
    while (buflen > 0) and (bufstr[buflen] = chr(0)) do dec(buflen);
    zsm[i].fname[0] := chr(buflen);
    }
  end;
end;


procedure prep_cmpstrings;
var
  bufstr: string[25];
  buflen: byte absolute bufstr;
  i, ii: byte;
begin

  for ii := 0 to 1 do
  begin

  move(cmpstr[ii], bufstr, ord(cmpstr[ii][0])+1);


  for i := 1 to buflen do
    bufstr[i] := ascw[ord(bufstr[i])];

  while (buflen > 0) and (bufstr[buflen] = chr(0)) do dec(buflen);


  if buflen > 0 then
  begin
    i := 1;
    while (i < buflen) and (bufstr[i] = chr(0)) do inc(i);
    move(bufstr[i], cmpstr[ii][1], buflen - i + 1);
    cmpstr[ii][0] := chr(buflen - i + 1);
  end;

  if cmpstr[ii][0] = chr(0) then
    cmpstr[ii]:=chr(255);

  end;

end;


  {
  swapvectors;
  exec('d:\conv\zsmplay.exe','d:\conv\appel /noloop /11khz' );
  swapvectors;
  writeln(doserror);
  }

procedure display_static_files;
  var i: byte;
begin
  textcolor(14);
  gotoxy(40 - ord(titlestring[0]) shr 1, 1); write(titlestring);
  textcolor(10);
  gotoxy(4, 2);
  write('Ϳ');
  gotoxy(4, 3);
  write(' numfilename title                    composer           year size ');
  gotoxy(5, 1); write('files');
  gotoxy(4, 4); write('ʹ');
  for i := 5 to 21 do
  begin
    gotoxy(4, i);
    if i and 1 = 1 then
    write('                                                                   ')
    else
    write('                                                                   ');
  end;
  gotoxy(4, 22);write(';');

  gotoxy(4, 23);
  write('list is ', sortedstate);
  gotoxy(34, 23); write( '(F)ilename (T)itle (C)omposer (Y)ear (S)ize');

  textcolor(12); gotoxy(4,24); write('ENTER: play     P: add to playlist     SPACE: show playlist     Esc: exit');
  textcolor(7); textbackground(1);
  gotoxy(4, 25); write('(M)ixing Frequency: ', mixfreq * 11025, ' Hz');

  write('           '); if not sb_set then textcolor(16+7);
    write('Soundblaster: (A) ', blasterbase2str(sb_base),
    '  (I)', irqlist[irqpos]:2, '  (D) ', dmalist[dmapos]);

  textbackground(0);
end;


procedure display_static_playlist;
  var i: byte;
begin
  textcolor(14);
  gotoxy(40 - ord(titlestring[0]) shr 1, 1); write(titlestring);
  textcolor(12);
  gotoxy(4, 2);
  write('Ϳ');
  gotoxy(4, 3);
  write(' numfilename title                    composer           year size ');
  gotoxy(5, 1); write('playlist');
  gotoxy(4, 4); write('ʹ');
  for i := 5 to 21 do
  begin
    gotoxy(4, i);
    if i and 1 = 1 then
    write('                                                                   ')
    else
    write('                                                                   ');
  end;
  gotoxy(4, 22);write(';');

  gotoxy(5,23); write('ENTER: play     move (U)p / (D)own     (Del)ete     SPACE: show fileslist');
  gotoxy(41, 24); write('play (L)ooped ['); if playlist_loop then
    write('X]') else write(' ]');
  gotoxy(41, 25); write('play (R)andom ['); if playlist_random then
    write('X]') else write(' ]');
end;



procedure display_files(start: word);
  var i, ende: word;
      y: byte;
      flen: byte absolute fill;
begin

  ende := start + 16;
  if ende > zsmcount then ende := zsmcount;
  y := 5;

  textcolor(10);
  for i := start to ende do
  begin
    if y - 4 = selectpos then textbackground(4) else textbackground(0);
    gotoxy(5, y); write(i:4);
    flen := 8 - ord(zsm_fname^[i][0]);
    gotoxy(10, y); write(zsm_fname^[i], fill);
    gotoxy(19, y); if zsm_title^[i][0] = chr(0) then
      write('(none)                   ') else
      begin
        flen := 25 - ord(zsm_title^[i][0]);
        write(zsm_title^[i], fill);
      end;
    gotoxy(45, y); if zsm_composer^[i][0] = chr(0) then
      write('(none)              ') else
      begin
        flen := 20 - ord(zsm_composer^[i][0]);
        write(zsm_composer^[i], fill);
      end;
    gotoxy(66, y); if zsm_year^[i] = $FFFF then
      write('   ?') else write(zsm_year^[i]);
    gotoxy(71, y); write(zsm_size^[i]:6);

    inc(y);
  end;
  textbackground(0);

  for i := y to 21 do
  begin
    gotoxy(5, i); write('    ');
    gotoxy(10, i); write('        ');
    gotoxy(19, i); write('                         ');
    gotoxy(45, i); write('                    ');
    gotoxy(66, i); write('    ');
    gotoxy(71, i); write('      ');
  end;

end;


procedure make_plist_ref;
  var i, ii: word;
begin
  for i := 1 to plistcount do
    for ii := 1 to zsmcount do
    if plistid[i] = zsm_id^[ii] then begin plist[i] := ii; break; end;
end;


procedure display_playlist(start: word);
  var i, ii, ende: word;
      y: byte;
      flen: byte absolute fill;
      p: word;
begin

  ende := start + 16;
  if ende > plistcount then ende := plistcount;
  y := 5;

  textcolor(12);
  for ii := start to ende do
  begin
    i := plist[ii];
    if y - 4 = selectplpos then textbackground(1) else textbackground(0);
    gotoxy(5, y); write(ii:4);
    flen := 8 - ord(zsm_fname^[i][0]);
    gotoxy(10, y); write(zsm_fname^[i], fill);
    gotoxy(19, y); if zsm_title^[i][0] = chr(0) then
      write('(none)                   ') else
      begin
        flen := 25 - ord(zsm_title^[i][0]);
        write(zsm_title^[i], fill);
      end;
    gotoxy(45, y); if zsm_composer^[i][0] = chr(0) then
      write('(none)              ') else
      begin
        flen := 20 - ord(zsm_composer^[i][0]);
        write(zsm_composer^[i], fill);
      end;
    gotoxy(66, y); if zsm_year^[i] = $FFFF then
      write('   ?') else write(zsm_year^[i]);
    gotoxy(71, y); write(zsm_size^[i]:6);

    inc(y);
  end;
  textbackground(0);

  for i := y to 21 do
  begin
    gotoxy(5, i); write('    ');
    gotoxy(10, i); write('        ');
    gotoxy(19, i); write('                         ');
    gotoxy(45, i); write('                    ');
    gotoxy(66, i); write('    ');
    gotoxy(71, i); write('      ');
  end;

end;


procedure randomize_playlist;
  var
    i, r: byte;
    in_list: bytebool;
begin
  for i := 1 to plistcount do
    repeat
      plrnd[i] := random(plistcount)+1;
      in_list := false;
      for r := 1 to i-1 do if plrnd[r] = plrnd[i] then in_list := true;
    until not in_list;
end;

procedure execute;
begin

  swapvectors;
  exec('zsmplay.exe', zsm_fname^[filespos+selectpos-1]+blasterstring+freqstring);
  swapvectors;

end;


procedure execute_playlist;
  var i: byte;
  pos: byte;
begin

  clrscr;

  if playlist_loop then
  begin
  pos := plistpos+selectplpos -1;
  while true do
  begin
    swapvectors;
    exec('zsmplay.exe', zsm_fname^[plist[plrnd[pos]]]+' /NOLOOP'+blasterstring+freqstring);
    swapvectors;
    if dosexitcode = 99 then break;
    inc(pos);
    if pos > plistcount then pos := 1;
  end;
  end
  else
  for  i := plistpos+selectplpos -1 to plistcount do
  begin

    swapvectors;
    exec('zsmplay.exe', zsm_fname^[plist[plrnd[i]]]+' /NOLOOP'+blasterstring+freqstring);
    swapvectors;
    if dosexitcode = 99 then break;

  end;


end;


procedure swap(frst, scnd: word);
begin

        zsm_title^[0] := zsm_title^[frst];
        zsm_composer^[0] := zsm_composer^[frst];
        zsm_fname^[0] := zsm_fname^[frst];
        zsm_year^[0] := zsm_year^[frst];
        zsm_size^[0] := zsm_size^[frst];
        zsm_id^[0] := zsm_id^[frst];


        zsm_title^[frst] := zsm_title^[scnd];
        zsm_composer^[frst] := zsm_composer^[scnd];
        zsm_fname^[frst] := zsm_fname^[scnd];
        zsm_year^[frst] := zsm_year^[scnd];
        zsm_size^[frst] := zsm_size^[scnd];
        zsm_id^[frst] := zsm_id^[scnd];

        zsm_title^[scnd] := zsm_title^[0];
        zsm_composer^[scnd] := zsm_composer^[0];
        zsm_fname^[scnd] := zsm_fname^[0];
        zsm_year^[scnd] := zsm_year^[0];
        zsm_size^[scnd] := zsm_size^[0];
        zsm_id^[scnd] := zsm_id^[0];

end;

procedure sort_size;
  var i, j: word;
begin
  textcolor(12); gotoxy(4, 23); write('sorting...      (A)bort   ');
  for i := zsmcount downto 1 do
  begin
    asm
      mov ax, 0b00h;
      int 21h;
      mov key, al;
    end;
    if key then
      if upcase(readkey) = 'A' then
      begin sortedstate := 'unsorted.          '; exit; end;
    gotoxy(15,23); write(100-(longint(i)*100) div zsmcount:3, '%');
    for j := 2 to i do
      if zsm_size^[j-1] > zsm_size^[j] then
      begin
{
  zsm_title: ^zsm_titletype absolute zsm_titles_pointer;
  zsm_composer: ^zsm_composertype absolute zsm_composers_pointer;
  zsm_fname: ^zsm_fnametype absolute zsm_fnames_pointer;
  zsm_year: ^zsm_wordtype absolute zsm_years_pointer;
  zsm_size: ^zsm_longinttype absolute zsm_sizes_pointer;
  zsm_id: ^zsm_wordtype absolute zsm_ids_pointer;
}       swap(j-1, j);

        {
        move(zsm[first], swapbuf, sizeof(swapbuf));
        move(zsm[second], zsm[first], sizeof(swapbuf));
        move(swapbuf, zsm[second], sizeof(swapbuf));
        }
      end;
  end;
  sortedstate := 'sorted by size.    '
end;


procedure sort_year;
  var i, j: word;
begin
  textcolor(12); gotoxy(4, 23); write('sorting...      (A)bort   ');
  for i := zsmcount downto 1 do
  begin
    asm
      mov ax, 0b00h;
      int 21h;
      mov key, al;
    end;
    if key then
      if upcase(readkey) = 'A' then
      begin sortedstate := 'unsorted.          '; exit; end;
    gotoxy(15,23); write(100-(longint(i)*100) div zsmcount:3, '%');
    for j := 2 to i do
      if zsm_year^[j-1] > zsm_year^[j] then
        swap(j-1, j);
      {
      begin

        move(zsm[first], swapbuf, sizeof(swapbuf));
        move(zsm[second], zsm[first], sizeof(swapbuf));
        move(swapbuf, zsm[second], sizeof(swapbuf));

      end;
      }
  end;
  sortedstate := 'sorted by year.    '
end;


procedure sort_filename;
  var i, j: word;
begin
  textcolor(12); gotoxy(4, 23); write('sorting...      (A)bort   ');
  for i := zsmcount downto 1 do
  begin
    asm
      mov ax, 0b00h;
      int 21h;
      mov key, al;
    end;
    if key then
      if upcase(readkey) = 'A' then
      begin sortedstate := 'unsorted.          '; exit; end;
    gotoxy(15,23); write(100-(longint(i)*100) div zsmcount:3, '%');
    for j := 2 to i do
      if zsm_fname^[j-1] > zsm_fname^[j] then
        swap(j-1, j);
  end;
  gotoxy(76,25); write('    ');
  gotoxy(50, 25); write('list is sorted by filename');
  sortedstate := 'sorted by filename.'
end;


procedure sort_composer;
  var i, j: word;
begin
  textcolor(12); gotoxy(4, 23); write('sorting...      (A)bort   ');
  for i := zsmcount downto 1 do
  begin
    asm
      mov ax, 0b00h;
      int 21h;
      mov key, al;
    end;
    if key then
      if upcase(readkey) = 'A' then
      begin sortedstate := 'unsorted.          '; exit; end;
    gotoxy(15,23); write(100-(longint(i)*100) div zsmcount:3, '%');
    for j := 2 to i do
    begin
      move(zsm_composer^[j-1], cmpstr[0], ord(zsm_composer^[j-1][0])+1);
      {cmpstr[0][0] := zsm[first].composer[0];}
      move(zsm_composer^[j], cmpstr[1], ord(zsm_composer^[j][0])+1);
      {cmpstr[1][0] := zsm[second].composer[0];}
      prep_cmpstrings;
      if cmpstr[0] > cmpstr[1] then
        swap(j-1, j);
    end;
  end;
  sortedstate := 'sorted by composer.'
end;


procedure sort_title;
  var i, j: word;
begin
  textcolor(12); gotoxy(4, 23); write('sorting...      (A)bort   ');
  for i := zsmcount downto 1 do
  begin
    asm
      mov ax, 0b00h;
      int 21h;
      mov key, al;
    end;
    if key then
      if upcase(readkey) = 'A' then
      begin sortedstate := 'unsorted.          '; exit; end;
    gotoxy(15,23); write(100-(longint(i)*100) div zsmcount:3, '%');
    for j := 2 to i do
    begin
      move(zsm_title^[j-1], cmpstr[0], ord(zsm_title^[j-1][0])+1);
      {cmpstr[0][0] := zsm[first].title[0];}
      move(zsm_title^[j], cmpstr[1], ord(zsm_title^[j][0])+1);
      {cmpstr[1][0] := zsm[second].title[0];}
      prep_cmpstrings;
      if cmpstr[0] > cmpstr[1] then
        swap(j-1, j);
    end;
  end;
  sortedstate := 'sorted by title.   '
end;


procedure add_to_playlist;
  var i: byte;
begin

  gotoxy(4, 24); write(' ');
  for i := 1 to 9 do write('       ');
  gotoxy(4, 24);
  if plistcount < 100 then begin
  inc(plistcount);
  plistid[plistcount] := zsm_id^[filespos+selectpos-1];
  write('                     ', zsm_fname^[filespos+selectpos-1]:8, ' added to playlist (', plistcount,')')
  end else
        write('                     playlist is full. (100)');
  for i := 1 to plistcount do plrnd[i] := i;
  playlist_random := false;

end;

procedure fileslist;
begin

    if ext_key then begin
      if ch = $48 then if selectpos > 1 then dec(selectpos)
        else if filespos > 1 then dec(filespos);
      if ch = $50 then if (selectpos < 17)
        and (selectpos < zsmcount) then inc(selectpos)
        else if filespos < (zsmcount-selectpos+1) then inc(filespos);

      if ch = 81 {pgdwn} then
      begin
        selectpos := 17;
        if selectpos > zsmcount then selectpos := zsmcount;
        inc(filespos, 17);
        if zsmcount < 18 then filespos := 1 else
        if filespos + 17 > zsmcount then filespos := zsmcount-16;
      end;

      if ch = 73 {pgup} then
      begin
        selectpos := 1;
        dec(filespos, 17);
        if filespos < 1 then filespos := 1;
      end;

      if ch = 71 then begin selectpos := 1; filespos := 1; end;
      if ch = 79 then
        if zsmcount < 18 then
        begin selectpos := zsmcount; filespos := 1; end
        else begin selectpos := 17; filespos := zsmcount-16; end;

    end
    else
    begin
      if ch = 13 then
      begin
        execute;
        display_static_files;
      end;
      if upcase(chh) = 'S' then begin sort_size; display_static_files end;
      if upcase(chh) = 'T' then begin sort_title; display_static_files end;
      if upcase(chh) = 'C' then begin sort_composer; display_static_files end;
      if upcase(chh) = 'Y' then begin sort_year; display_static_files end;
      if upcase(chh) = 'F' then begin sort_filename; display_static_files end;

      if upcase(chh) = 'P' then add_to_playlist;

      if upcase(chh) = 'A' then
      begin
        sb_set := true;
        inc(sb_base, $10);
        if sb_base > $260 then sb_base := $210;
        display_static_files;
        make_blasterstring;
      end;

      if upcase(chh) = 'I' then
      begin
        sb_set := true;
        inc(irqpos);
        if irqpos > 7 then irqpos := 1;
        display_static_files;
        make_blasterstring;
      end;

      if upcase(chh) = 'D' then
      begin
        sb_set := true;
        inc(dmapos);
        if dmapos > 6 then dmapos := 1;
        display_static_files;
        make_blasterstring;
      end;


      if upcase(chh) = 'M' then
      begin
        if mixfreq = 4 then mixfreq := 1 else
          if mixfreq = 2 then mixfreq := 4 else
           if mixfreq = 1 then mixfreq := 2;
        display_static_files;
        str(mixfreq*11, freqstring);
        freqstring := ' /'+freqstring+'KHZ';
      end;


      if ch = 32 then
      begin
        mode := 2;
        clrscr;
        make_plist_ref;
        display_static_playlist;
        display_playlist(plistpos);
      end;

    end;
    if ch <> 32 then display_files(filespos);
end;


procedure playlist;
  var i: byte;
begin

    if ext_key then begin
      if ch = $48 then if selectplpos > 1 then dec(selectplpos)
        else if plistpos > 1 then dec(plistpos);
      if ch = $50 then if (selectplpos < 17)
        and (selectplpos < plistcount) then inc(selectplpos)
        else if plistpos < (plistcount-selectplpos+1) then inc(plistpos);

      if ch = 81 {pgdwn} then
      begin
        selectplpos := 17;
        if selectplpos > plistcount then selectplpos := plistcount;
        inc(plistpos, 17);
        if plistcount < 18 then plistpos := 1 else
        if plistpos + 17 > plistcount then plistpos := plistcount-16;
      end;

      if ch = 73 {pgup} then
      begin
        selectplpos := 1;
        dec(plistpos, 17);
        if plistpos < 1 then plistpos := 1;
      end;

      if ch = 71 then begin selectplpos := 1; plistpos := 1; end;
      if ch = 79 then
        if plistcount < 18 then
        begin selectplpos := plistcount; plistpos := 1; end
        else begin selectplpos := 17; plistpos := plistcount-16; end;

      if ch = 83 then if plistcount > 0 then
      begin
        for i := plistpos + selectplpos - 1 to plistcount-1 do
        begin
          plist[i] := plist[i+1];
          plistid[i] := plistid[i+1];
        end;
        dec(plistcount);
        if plistpos + selectplpos - 1 > plistcount then
          if selectplpos > 1 then dec(selectplpos);
      end;


    end
    else
    begin
      if ch = 13 then
      begin
        if playlist_random then randomize_playlist;
        execute_playlist;
        for i := 1 to plistcount do plrnd[i] := i;
        display_static_playlist;
        display_playlist(plistpos);
      end;

      if upcase(chr(ch)) = 'U' then
      begin

        if (plistpos + selectplpos -1) > 1 then begin

        plist[0] := plist[plistpos+selectplpos-2];
        plistid[0] := plistid[plistpos+selectplpos-2];

        plist[plistpos+selectplpos-2] := plist[plistpos+selectplpos-1];
        plistid[plistpos+selectplpos-2] := plistid[plistpos+selectplpos-1];

        plist[plistpos+selectplpos-1] := plist[0];
        plistid[plistpos+selectplpos-1] := plistid[0];

        if selectplpos > 1 then dec(selectplpos)
        else if plistpos > 1 then dec(plistpos);

        end;

      end;


      if upcase(chr(ch)) = 'D' then
      begin

        if (plistpos + selectplpos -1) < plistcount then
        begin

        plist[0] := plist[plistpos+selectplpos];
        plistid[0] := plistid[plistpos+selectplpos];

        plist[plistpos+selectplpos] := plist[plistpos+selectplpos-1];
        plistid[plistpos+selectplpos] := plistid[plistpos+selectplpos-1];

        plist[plistpos+selectplpos-1] := plist[0];
        plistid[plistpos+selectplpos-1] := plistid[0];


        if (selectplpos < 17)
        and (selectplpos < plistcount) then inc(selectplpos)
        else if plistpos < (plistcount-selectplpos+1) then inc(plistpos);

        end;

      end;


      if upcase(chr(ch)) = 'L' then
      begin playlist_loop := not playlist_loop; display_static_playlist
      end;
      if upcase(chr(ch)) = 'R' then
      begin
        playlist_random := not playlist_random;
        display_static_playlist;
      end;

      if ch = 32 then
      begin
        mode := 1;
        clrscr;
        display_static_files;
        display_files(filespos);
      end;


    end;
    if ch <> 32 then display_playlist(plistpos);
end;


procedure save_cfg;
  var f: text;
  i: byte;
begin
  assign(f, 'zsmstart.cfg');
  {$I-}
  rewrite(f);
  if ioresult <> 0 then writeln('failed to save cfg.');
  {$I+}

  writeln(f, plistcount);
  for i := 1 to plistcount do
    writeln(f, zsm_fname^[plist[i]]);

  writeln(f, mixfreq);

  if sb_set then
  begin
    writeln(f, blasterbase2str(sb_base));
    writeln(f, irqlist[irqpos]);
    writeln(f, dmalist[dmapos]);
  end;

  close(f);
end;


procedure read_cfg;
  var f: text;
  i: byte;
  blasterbase: string[3];
begin
  assign(f, 'zsmstart.cfg');
  {$I-}
  reset(f);
  if ioresult <> 0 then exit;
  {$I+}

  readln(f, plistcount);

  for i := 1 to plistcount do
    readln(f, pl_cfgfname[i]);

  readln(f, mixfreq);

  readln(f, blasterbase);
  readln(f, sb_irq);
  readln(f, sb_dma);

end;


procedure reconstruct_playlist;
  var i: word;
      c, p: byte;
begin

  c := plistcount;
  plistcount := 0;
  for p := 1 to c do
  begin
    i := 1;
    while (i < zsmcount + 1) and (zsm_fname^[i] <> pl_cfgfname[p]) do inc(i);
    if i < zsmcount + 1 then
    begin
      inc(plistcount);
      plistid[plistcount] := zsm_id^[i];
    end;
  end;

  make_plist_ref;
  for i := 1 to plistcount do plrnd[i] := i;

end;


begin
  fillchar(ascw, 256, 0);
  move(ascweigh, ascw[48], 75);
  plistcount := 0;
  sortedstate := 'unsorted.          ';
  mixfreq := 4;
  sb_set := false;

  if not sb_set then get_sbenv;
  if sb_base = 0 then
  begin
    sb_set := false;
    sb_base := $220;
    sb_irq := 7;
    sb_dma := 1;
  end
  else
    sb_set := true;

  read_cfg;
  find_dma_and_irq_pos;

  make_blasterstring;

  get_memory;
  mode := 1;
  fillchar(fill[1], 25, 32);
  toomany := false;
  playlist_random := false;
  playlist_loop := false;

  write('searching files...');
  find_files;
  if filecount > 2000 then begin filecount := 2000; toomany := true; end;
  writeln;
  write('reading file headers...');
  read_in_details;
  trunc_lengths;
  {
  writeln;
  show_files;
  }

  filespos := 1;
  selectpos := 1;
  plistpos := 1;
  selectplpos := 1;
  textbackground(0);
  clrscr;
  if (failcount > 0) or toomany or (zsmcount = 0) then
  begin
    textcolor(12);
    if toomany then begin gotoxy(30, 12); write('more than 2000 files - only 2000 loaded.'); end;
    if failcount > 0 then begin gotoxy(30, 13); write('invalid files skipped: ', failcount); end;
    if zsmcount = 0 then begin gotoxy(30, 14); write('no files found.'); end;
    gotoxy(30, 16); write('any key to continue');
    ch := ord(readkey);
    if ch = 0 then ch := ord(readkey);
    clrscr;
    if zsmcount = 0 then halt(1);
  end;

  reconstruct_playlist;

  display_static_files;
  display_files(filespos);

  asm mov ah, 01h; mov cx, 2607h; int 10h; end; { cursor verstecken }

  repeat

    ext_key := false;
    ch := ord(readkey);
    if ch = 0 then begin ch := ord(readkey); ext_key := true; end;

    if mode = 1 then fileslist else playlist;

  until ch = 27;

  asm mov ah, 01h; mov cx, 0607h; int 10h; end;
  textcolor(7);
  clrscr;


{
  Anzeigen:
  - Enter to play selected Song, P add to Playlist, SPACE show Playlist
  - sorted by composer. use Cursor Up/Down, PgUp/PgDown, Pos1/End to scroll
}
  save_cfg;

end.